---------------------------------
-- Serial  Controler
---------------------------------


-- Notes -----------------------------------
-- 2007.03.15
---- buffer傫܂B
-- 2007.03.14
---- 1clockɂ邩vZāA҂tF[Y܂B
---- n STATE -> wait STATE -> n+1 STATE -> wait STATE ->...
---- ƂBƂHiĂȂ炢1clockǁBj
-- 2007.03.13
---- 쐬
---- Ƃ肠A1clock1ƂŏĂ݂Ă܂B
---- rs232c̋āAv肸ƒxH130clockƂ́HHmF悤
---- ̂悤ɂȂobt@͉̕łǁA葁Ȃobt@mۂׂB
---- zmۂĂׂHƂxN^[̂΂őΉHǂɂ傫ȂRAMtH
--------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use UNISIM.VCOMPONENTS.all;

entity SERIAL is
    port(CLK : in std_logic;
        RESET : in std_logic;
        --ADM
        RxD : in std_logic;
        TxD : out std_logic;
        --CPU
	   RS : out std_logic_vector(3 downto 0);
        DO : in std_logic;                              -- When Start 1
        WR : in std_logic;                              -- W = '1' R = '0'
        WD : in std_logic_vector(7 downto 0);
        RD : out std_logic_vector(7 downto 0);
        VALID : out std_logic;
	   BUSY : out std_logic
    );
end SERIAL;

architecture ARC of SERIAL is

    signal STATE,NSTATE,RSTATE,NRSTATE : std_logic_vector(3 downto 0);
    signal WBUF : std_logic_vector(7 downto 0);
    signal RBUF : std_logic_vector(7 downto 0);
    --signal BUF : std_logic_vector(63 downto 0);
    signal CNT,RCNT : integer;
    signal CLKCNT,CLKCNTW : integer;
    signal TxDB : std_logic;

	signal BWR : std_logic;
	signal BWDATA : std_logic_vector(7 downto 0);
	signal BRDATA : std_logic_vector(7 downto 0);
	signal BADDR : std_logic_vector(7 downto 0);
   signal T1,T2 : integer;

    constant CLKSPEED : integer := 25 * 1000 * 1000/2;
    constant BAUD : integer := 38400 * 3;   -- default
    constant CLKS : integer := CLKSPEED / BAUD;
    constant CLKS_ST : integer := CLKS * 3 / 2 ;

	component SERIAL_BUF
		port(
		CLK : in std_logic;
		RESET : in std_logic;
		WR : in std_logic;
		WDATA : in std_logic_vector(7 downto 0);
		RDATA : out std_logic_vector(7 downto 0);
		ADDR : in std_logic_vector(7 downto 0)
		);
	end component;

begin
	BINST : SERIAL_BUF port map(
		CLK => CLK,
		RESET => RESET,
		WR => BWR,
		WDATA => BWDATA,
		RDATA => BRDATA,
		ADDR => BADDR
		);

   --T1 <= CLKS;
   --T2 <= CLKS_ST;

	RS <= RSTATE;

    process(CLK,RESET)
    begin
        if RESET = '1' then
            STATE <= "0000";
            RSTATE <= "0000";
            NSTATE <= "0000";
            NRSTATE <= "0000";
		  BUSY <= '0';
            VALID <= '0';
            CNT <= 0;
            RCNT <= 0;
            CLKCNT <= 0;
            CLKCNTW <= 0;
        elsif CLK'event and CLK = '1' then
            case RSTATE is
                when "0000" =>
			 	if CNT >= 255 then
					CNT <= 0;
				end if;
			 	BWR <= '0'; 
                    if RxD = '0' then
                        NRSTATE <= "0001";
                        CLKCNT <= 0;
                        RSTATE <= "1010";
                    else
                        RSTATE <= "0000";
                    end if;
                when "0001" =>
                    RBUF(7) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0010" =>
                    RBUF(6) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0011" =>
                    RBUF(5) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0100" =>
                    RBUF(4) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0101" =>
                    RBUF(3) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0110" =>
                    RBUF(2) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "0111" =>
                    RBUF(1) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "1000" =>
                    RBUF(0) <= RxD;
                    CLKCNT <= 0;
                    RSTATE <= "1011";
                    NRSTATE <= RSTATE + 1;
                when "1001" =>
                    RSTATE <= "0000";
				BWR <= '1';
				BWDATA <= RBUF;
				 BADDR <= CONV_STD_LOGIC_VECTOR(CNT,8);
				CNT <= CNT + 1;
                when "1010" => -- wait dt * 1.5
                    if CLKCNT = CLKS_ST then
                        RSTATE <= NRSTATE;
                        CLKCNT <= 0;
                    else
                        RSTATE <= "1010";
                        CLKCNT <= CLKCNT + 1;
                    end if;                    
                when "1011" =>-- wait dt
                    if CLKCNT = CLKS then
                        RSTATE <= NRSTATE;
                        CLKCNT <= 0;
                    else
                        RSTATE <= "1011";
                        CLKCNT <= CLKCNT + 1;
                    end if;
                when others =>
                    CLKCNT <= 0;
                    RSTATE <= "0000";
            end case;
            case STATE is
                when "0000" =>
                    VALID <= '0';
                    TxD <= '1';
                    if DO = '1' then
					BUSY <= '1';
                        if WR = '1' then
                            WBUF <= WD;
                            STATE <= "0001";
                        else
                            STATE <= "1110";
                        end if;
                    else
                        STATE <= "0000";
                    end if;
                when "0001" => --write
                    TxD <= '0';
                    TxDB <= '0';
                    STATE <= "1011";
                    CLKCNTW <= 0;
                    NSTATE <= STATE + 1;
                when "0010" =>
                    TxD <= WBUF(7);
                    TxDB <= WBUF(7);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "0011" =>
                    TxD <= WBUF(6);
                    TxDB <= WBUF(6);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "0100" =>
                    TxD <= WBUF(5);
                    TxDB <= WBUF(5);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "0101" =>
                    TxD <= WBUF(4);
                    TxDB <= WBUF(4);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "0110" =>
                    TxD <= WBUF(3);
                    TxDB <= WBUF(3);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "0111" =>
                    TxD <= WBUF(2);
                    TxDB <= WBUF(2);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "1000" =>
                    TxD <= WBUF(1);
                    TxDB <= WBUF(1);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "1001" =>
                    TxD <= WBUF(0);
                    TxDB <= WBUF(0);
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= STATE + 1;
                when "1010" =>
                    TxD <= '1';
                    TxDB <= '1';
                    CLKCNTW <= 0;
                    STATE <= "1011";
                    NSTATE <= "1100";
                when "1011" => -- wait dt
                    if CLKCNTW = CLKS then
                        STATE <= NSTATE;
                        CLKCNTW <= 0;
                    else
                        STATE <= "1011";
                        CLKCNTW <= CLKCNTW + 1;
                        TxD <= TxDB;
                    end if;
		    	when "1100" =>
			    	STATE <= "0000";
			    	BUSY <= '0';
                when "1110" => --read
                    --TxD <= '1';
                    if CNT = RCNT then
                        STATE <= "1110";
                    else
				        BWR <= '0';
					    BADDR <= CONV_STD_LOGIC_VECTOR(RCNT,8);
					    RCNT <= RCNT + 1;
                        STATE <= STATE + 1;
                    end if;
			    when "1111" =>
				    if RCNT >= 255 then
					    RCNT <= 0;
				    end if;
				    RD <= BRDATA;
				    VALID <= '1';
				    STATE <= "0000";
				    BUSY <= '0';
                when others =>
                    STATE <= "0000";
                    VALID <= '0';
            end case;
        end if;
    end process;

end ARC;
