-----------------------------------
-- Serial Buffer
----------------------------------

-- Notes --------------------------
-- 2007.03.15
----
-----------------------------------


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use UNISIM.VCOMPONENTS.all;

entity SERIAL_BUF is
	port(
		CLK : in std_logic;
		RESET : in std_logic;
		WR : in std_logic;
		WDATA : in std_logic_vector(7 downto 0);
		RDATA : out std_logic_vector(7 downto 0);
		ADDR : in std_logic_vector(7 downto 0)
		);

end SERIAL_BUF;

architecture ARC of SERIAL_BUF is

   subtype byte is std_logic_vector(7 downto 0);
    type MEM_TYPE is array(256 downto 0) of byte;

    signal BUF : MEM_TYPE;

begin
	process(CLK,RESET)
	begin
		if RESET = '1' then
			RDATA <= (others => '0');
		elsif CLK'event and CLK = '1' then
			if WR = '1' then -- write
				BUF(CONV_INTEGER(ADDR)) <= WDATA;
			else -- read
				RDATA <= BUF(CONV_INTEGER(ADDR));
			end if;

		end if;
	end process;
end ARC;