------------------------------
-- rs232c echo test
------------------------------


-- Notes ---------------------------
-- 2007.03.15
---- Ă݂܂BGR[pt@CB
------------------------------------

library UNISIM;
use UNISIM.VCOMPONENTS.all;

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity STEST is
    port(CLKIN : in std_logic;
        LED : out std_logic_vector(7 downto 0);
        TxD : out std_logic;
        RxD : in std_logic
    );
end STEST;

architecture ARC of STEST is

    component ROC
    port( O : out std_logic);
    end component;

    component IBUFG
    port(I : in std_logic;
        O : out std_logic);
    end component;

    component SERIAL 
    port(CLK : in std_logic;
        RESET : in std_logic;
        --ADM
        RxD : in std_logic;
        TxD : out std_logic;
        --CPU
	   RS : out std_logic_vector(3 downto 0);
        DO : in std_logic;                              -- When Start 1
        WR : in std_logic;                              -- W = '1' R = '0'
        WD : in std_logic_vector(7 downto 0);
        RD : out std_logic_vector(7 downto 0);
        VALID : out std_logic;
	   BUSY : out std_logic
    );
    end component;

    component BUFG
    	port(I : in std_logic;
		O : out std_logic);
	end component;

    signal CLK,MIDCLK : std_logic;
    signal RESET : std_logic;
    signal START : std_logic;
    signal WDATA : std_logic_vector(7 downto 0);
    signal RDATA : std_logic_vector(7 downto 0);
    signal VAL,BUSY : std_logic;
    signal WR : std_logic;
    signal RS : std_logic_vector(3 downto 0);
    signal RB : std_logic;

    signal STATE : std_logic_vector(3 downto 0);

begin

   RC : ROC port map (
        O => RESET);

    -- Inner clk is "CLK"
    IBG : IBUFG port map (
        I => CLKIN,
        O => MIDCLK);

	BG : BUFG port map(
		I=> MIDCLK,
		O=> CLK
	);

    SERIAL_INST : SERIAL port map(
    CLK => CLK,
    RESET => RESET,
    RxD => RxD,
    TxD => TxD,
    RS => RS,
    DO => START,
    WR => WR,
    WD => WDATA,
    RD => RDATA,
    VALID => VAL,
    BUSY => BUSY
    );

	RB <= RxD;
    LED <= not (RB & STATE(2 downto 0) & RS);

    process(CLK,RESET)
    begin
        if RESET = '1' then
            WDATA <= (others=> '0');
            START <= '0';
            STATE <= "0000";
            WR <= '0';
        elsif CLK'event and CLK = '1' then
            case STATE is
                when "0000" =>
			 	if BUSY = '0' then
                    	WR <= '0';
                    	START <= '1';
                    	STATE <= STATE + 1;
				else
					STATE <= "0000";
				end if;
                when "0001" =>
                    if VAL = '1' then
                        START <= '1';
                        WR <= '1';
                        WDATA <= RDATA;
                        STATE <= "0000";
                    else
                        START <= '0';
                        STATE <= "0001";
                    end if;
                when others =>
                    STATE <= "0000";
            end case;
        end if;
	end process;

end ARC;
